#ifndef SHELLICONPROVIDER_H
#define SHELLICONPROVIDER_H

#include <QObject>
#include <QCache>
#include <QString>
#include <QPixmap>
#include <QQuickAsyncImageProvider>

class ShellIconProvider : public QQuickImageProvider
{
public:
    ShellIconProvider() : QQuickImageProvider(QQuickImageProvider::Pixmap), iconCache(512)
    {
    }

    ImageType imageType() const;

    QPixmap requestPixmap(const QString &id, QSize *size, const QSize &requestedSize);

    static QString getIconURIByPath(const QString& path);

    static QString getImageURIByPath(const QString& path);

    static QString getPrefix();

private:
    QPixmap getIconFromShellItemImage(const QString& path, const QSize &requestedSize);

private:
    struct ShellIcons
    {
        QPixmap largeIco;
        QPixmap smallIco;
    };

    QCache<QString, ShellIcons> iconCache;
    QPixmap                     defaultIcon;
    static QString              providerPrefix, largeIconPrefix, smallIconPrefix;
};

#endif // SHELLICONPROVIDER_H
